	 /*8crc窺pⷽX,dp,iHpN8쪺h*/
#include <stdio.h>
#include <String.h>
unsigned int Tab[256];
///////////////////////////////////////////////////////////////////////////////////////////
/*initial table*/
void InitCRC(unsigned int Poly,unsigned int r,unsigned int *CRC_Table)
{
	int i,j;
	unsigned int uiTemp;
		
	for(i=0;i<256;i++)
	{
		uiTemp = i;
		for(j=0;j<r;j++)
		{
			uiTemp = uiTemp <<1;
			uiTemp = (uiTemp & (1<<r))?uiTemp^Poly:uiTemp;
		}
		CRC_Table[i] = uiTemp & ((1<<r)-1);
	}
}

//////////////////////////////////////////////////////////////////////////////////////////
/*calculate the crc result*/
unsigned int calculateCrc8(unsigned char *pData,unsigned int Len)
{
	static unsigned char madeTable = 0;
	unsigned int i;
	unsigned int ucResult = 0;
	if (!madeTable)
	{
	    madeTable = 1;
	    InitCRC(0x19,8,Tab);	// Enter your CRC polynomial as bit sequence ("100110001") here:
	                            // P(x) = x^8+x^7+x^6+x^5+x^4+x^3+x^2+x^1+x^0
	                            //         1    0   0   0   1  1   0   0   1  => 0x19    
	}  
	for(i=0;i<Len;i++)
	{
		ucResult = Tab[ucResult ^(*(pData+i))];
	}
	return ucResult;
}


/////////////////////////////////////////////////////////////////////////////////////////
/*simple test*/

void test_crc(void)
{
	unsigned char Data[122];
#ifdef _DEBUG_
	printf("testing...\r\n");
#endif
	InitCRC(0x19,8,Tab);
	memset(Data,125,122);
#ifdef _DEBUG_
	printf("crc=%d\r\n",	CRCCalculate(Data,122));
	printf("test done.\r\n");
#endif
}



