
#ifndef	_RA8870_H
#define _RA8870_H

	// ra8870 d0-d15 -------- D0-D15
	// ra8870 #d/c   -------- A16
	// ra8870 #cs    -------- NE1
	// ra8870 #wr    -------- WR
	// ra8870 #rd    -------- RD
	
	#define LCD_COMM_ADD		*((uint16_t *)0X60020000)	
	#define LCD_DATA_ADD		*((uint16_t *)0X60000000)

	#define writeCommand(cmd)	{RA8870_WAITSTATUS();LCD_COMM_ADD = cmd;}
    #define writeData(data)		{RA8870_WAITSTATUS();LCD_DATA_ADD = data;}




void InitializeRa8870(void);
void RA8870_WAITSTATUS(void);
void Memory_Clear_with_Font_BgColor(void);
void Chk_Busy(void);
void XY_Coordinate(uint16_t X,uint16_t Y);
uint16_t readBackColor(void);
 void lcdClear(uint16_t color);
void HDIR_SEG0_SEGn(void);
void VDIR_COM0_COMn(void);
void HDIR_SEGn_SEG0(void);
void VDIR_COMn_COM0(void);


#endif



