
#include "includes.h"

SOFT_TIMER	softTimer[TIMER_COUNT];
uint32_t beepDuration; 
extern state_id actualState;                    /* 檺A  */
uint8_t cursoronoff;


/* tΤ_Ƶ{	1ms @ */
void systemTickIsr(void)
{
    
}

void extfilterV(void);
void extfilterI(void);
void delay5us(uint32_t nus)
{
	uint32_t time;
	nus *= 145;
    for (time = 0 ; time < nus ; time++)
	   ;
}

/* Block Delay */	   
void delayMs(uint32_t nMs)
{
	static uint8_t flag = 0;
	uint32_t time;
	flag = 1;
	time = softTimer[MAIN_COUNT].count;
	if (nMs > 90)
	{
		while ((softTimer[MAIN_COUNT].count - time) < nMs)	
		{
#ifdef	W_WATCH_DOG
	  WWDG_SetCounter(127);
#endif
#ifdef 	I_WATCH_DOG
/* Reload IWDG counter */
    IWDG_ReloadCounter();  
#endif
			if ((softTimer[MAIN_COUNT].count % 5 == 0) && (flag == 1))
			{
				flag = 0;
//				HVVoltage();
			}
			else
				flag = 1;
		}
	}
	else
	{
		if (nMs == 0)
			return;
		while ((softTimer[MAIN_COUNT].count - time) < nMs)
#ifdef	W_WATCH_DOG
	  WWDG_SetCounter(127);
#else
 #ifdef I_WATCH_DOG
/* Reload IWDG counter */
    IWDG_ReloadCounter();  
#endif
		;
#endif
	}			  
}





/*==================================================================================*/
/* Buzzer TɶWL (time) ms ,Y                                                 */
/*==================================================================================*/
void beepTimeOut(void)
{
	if (softTimer[BUZZER_COUNT].flag == ENABLE)
	{
		if (softTimer[MAIN_COUNT].count - softTimer[BUZZER_COUNT].count > (beepDuration ))	 /* non Block delay 70ms ﾹɶ */
		{
			stopBeep();
		}
	}
}

void clearOnTheFlyCursor(void)
{
	if (softTimer[ON_THE_FLY_COUNT].flag == ENABLE)
	{
		softTimer[ON_THE_FLY_COUNT].flag = DISABLE;
		cursorPosition = 0;
		CLR_SETTING;
		CLR_NUMBER;
		displayFresh = 1;
		CLR_FIX_CURSOR;
	}
}

void checkOnTheFlyCursor(void)
{
	if (softTimer[ON_THE_FLY_COUNT].flag == ENABLE)
	{
		if (!IS_FIX_CURSOR)
		{
			if (softTimer[MAIN_COUNT].count - softTimer[ON_THE_FLY_COUNT].count > (10000 ))	 /*  20 seconds }*/
			{
				if(cursoronoff == 0)
					clearOnTheFlyCursor();
			}
		}
	}
}

void setOnTheFly(void)
{
	softTimer[ON_THE_FLY_COUNT].flag = ENABLE;
	softTimer[ON_THE_FLY_COUNT].count = softTimer[MAIN_COUNT].count;
}


void errorMessageTimeOut(void)
{
	if (softTimer[ERROR_MESSAGE_COUNT].flag == ENABLE)
	{
		if (softTimer[MAIN_COUNT].count - softTimer[ERROR_MESSAGE_COUNT].count > (1500 ))	 /* non Block delay 1.5s  */
		{

		     memcpy((void *)(displayBuffer + 19),(void *)displayBufferTemp,29);
			 displayFresh = 1;
			 cursorPosition = cursorPositionTemp;
			 CLR_NUMBER;
			 softTimer[ERROR_MESSAGE_COUNT].flag = DISABLE;
			 if (IS_SETTING == 0 && IS_FROM_MENU)
				 flashBlock(1);
		}
	}
}

void showVer(uint32_t time)
{
	static uint32_t showCount = 0;

	if (softTimer[SHOW_VERSION_COUNT].flag == ENABLE)
	{
		showCount++;
		if (softTimer[MAIN_COUNT].count - softTimer[SHOW_VERSION_COUNT].count < (time))
		{
			sprintf((void *)(displayBuffer),"MAIN:              ");
			sprintf((void *)(displayBuffer+19),"PW:      PF:      GP:        ");
			memcpy((void *)(displayBuffer+5),SCPI_DEV_VERSION ,5);
			if (strlen((void *)measurementInf) > 10)
				memcpy((void *)(displayBuffer+19+3),(void *)(measurementInf + 16) ,5);
			else
				memcpy((void *)(displayBuffer+19+3),(void *)(measurementInf) ,5);
			memcpy((void *)(displayBuffer+19+12),(void *)(pfcInf + 16) ,5);
			memcpy((void *)(displayBuffer+19+21),(void *)(gpibInf + 22) ,6);
		}
		else
		{
			softTimer[SHOW_VERSION_COUNT].flag = DISABLE;
			memset((void *)displayBuffer,' ',49);
			displayFresh = 1;
		}
		if (showCount % 50 == 0)
			dispVFD48(DISPBUF);
	}
}


/* ɶƥBz */
void timeEvent(void)
{

}



