

#include    "includes.h"
#include	"fonts.h"
#include    "BKimage.h"

static __IO uint16_t s_TextColor = WHITE;
static __IO uint16_t s_BackColor = BLACK;

uint8_t   disptp = 0;
uint8_t   displayBuffer[128];
uint8_t   displayLength = 0;

const uint16_t blockColor = GRAY2;


sBLOCK  B0 =
{
    0,0,	   //W
	0,226,	   //U
	479,0,	   //kW
	479,226,	   //kU
	GRAY2	   //I
};


sBLOCK  B1 =
{
    0,227,	   //W
	0,271,	   //U
	95,227,	   //kW
	95,271,	   //kU
	GRAY0	   //I
};
sBLOCK  B2 =
{
    96,227,	   //W
	96,271,	   //U
	191,227,	   //kW
	191,271,	   //kU
	GRAY0	   //I
};
sBLOCK  B3 =
{
    192,227,	   //W
	192,271,	   //U
	287,227,	   //kW
	287,271,	   //kU
	GRAY0	   //I
};
sBLOCK  B4 =
{
    288,227,	   //W
	288,271,	   //U
	383,227,	   //kW
	383,271,	   //kU
	GRAY0	   //I
};
sBLOCK  B5 =
{
    384,227,	   //W
	384,271,	   //U
	479,227,	   //kW
	479,271,	   //kU
	GRAY0	   //I
};
sBLOCK  R1 =
{
    384,0,	   //W
	384,55,	   //U
	479,0,	   //kW
	479,55,	   //kU
	GRAY0	   //I
};
sBLOCK  R2 =
{
    384,56,	   //W
	384,111,	   //U
	479,56,	   //kW
	479,111,	   //kU
	GRAY0	   //I
};
sBLOCK  R3 =
{
    384,112,	   //W
	384,167,	   //U
	479,112,	   //kW
	479,167,	   //kU
	GRAY0	   //I
};
sBLOCK  R4 =
{
    384,168,	   //W
	384,223,	   //U
	479,168,	   //kW
	479,223,	   //kU
	GRAY0	   //I
};















sFONT    font1 =
{
    FONT7X11,
	7,
	11
};

sFONT    font2 =
{
    FONT9X15,
	9,
	15
};

sFONT    font3 =
{
    FONT10X17,
	10,
	17
};

sFONT    font4 =
{
    FONT23X44,
	23,
	44
};

sFONT    font5 =
{
    FONT38X72,
	36,
	72
};

/* 
	s_Transparent = 1 ܤrɡAקIC
*/
static __IO uint8_t s_Transparent = NONE_TRANSPARENT;



void set_s_TextColor(uint16_t color)
{
    s_TextColor = color;
}


/**************************************************************************************
\yz: b̹ܤ@ 16bit bmpϧ
    J: uint16_t* image    	ϧμuƲզa}
          uint16_t x,y			W
	  	  uint16_t width,height	ϧΪeשM
    X: L
**************************************************************************************/
void printLcd16BitBmp(uint16_t* image,uint16_t x,uint16_t y,uint16_t width,uint16_t height)
{
	uint16_t w,h;
	
	for(h=0;h<height;h++)
	{
//		XY_Coordinate(x,y+h);
//		writeCommand(0x02);		//MRWC  REG[02h] -- Memory Read/Write Command
		for(w = 0; w< width; w++)
		{
//			writeData(*image++);
		}
	}
}

void printBKLogo(void)
{
	  printLcd16BitBmp((uint16_t*)gImage_BK,61,40,357,68);
}


/*******************************************************************************
*	ƦW: drawLcdChar (e@r)
*	  :
*		Xpos :X
*		Ypos: Y
*		font: r	0: (7*11) 1:(9*15) 2:(10*17) 3:(23*44)
*		c : VrI}w
*	  ^: L
*	\  : bLCDWܤ@Ӧr
*********************************************************************************
*/
void drawLcdChar(uint16_t Xpos, uint16_t Ypos, sFONT *font ,const uint8_t *c)
{
	uint32_t index,i;
	uint16_t Yaddress = Ypos,Xaddress = Xpos;

//	XY_Coordinate(Xpos, Ypos); /* X,Y w */
	for (index = 0; index < font->high; index++)	/* rŰ (Xfont/8 + 1):rżeשҥebyte*/
    {
//		writeCommand(0x02);		//MRWC  REG[02h] -- Memory Read/Write Command
		for (i = 0; i < font->width; i++)			/* rże */
		{
			if ((c[((font->width/8 + 1)*index)+(i/8)] & (0x80 >> (i%8))))	  // MSB -> LSB
			{
//				writeData(s_TextColor);
			    Xpos++;  	
			}
			else
			{
				if (s_Transparent == 1) //z I 
				{
//					writeData(s_BackColor);
					Xpos++;
				}
				else   //z IC⤣
				{	 
					Xpos++;
//					XY_Coordinate(Xpos, Yaddress); // Xb[@ w
//					writeCommand(0x02);		//MRWC  REG[02h] -- Memory Read/Write Command
				}
			}
		}
		Yaddress++;
		Xpos = Xaddress;
//		XY_Coordinate(Xaddress, Yaddress);
	}
}


//d
 void lookLcdTableChar(uint16_t Xpos, uint16_t Ypos,sFONT *font, uint8_t Ascii)
{
	if (font->table == FONT38X72)
	{
	    if 	(Ascii >= '+' && Ascii <= '.') // +  ,  -  .
			Ascii -= '+';
		else if (Ascii >= '0' && Ascii <= '9')
			Ascii -= 44;
		else if (Ascii == 'F')
			Ascii = 14;
		else if (Ascii == 'G')
			Ascii = 15;
		else if (Ascii == 'H')
			Ascii = 16;
		else if (Ascii == 'K')
			Ascii = 17;
		else if (Ascii == 'M')
			Ascii = 18;
		else if (Ascii == 'S')
			Ascii = 19;
		else if (Ascii == 'T')
			Ascii = 20;
		else if (Ascii == '\\')	//mu
			Ascii = 21;
		else if (Ascii == '_')	//ohm
			Ascii = 22;
		else if (Ascii == 'e')  
			Ascii = 23;
		else if (Ascii == 'm')
			Ascii = 24;
		else if (Ascii == 'n')
			Ascii = 25;
		else if (Ascii == 'p')
			Ascii = 26;
		else if (Ascii == 0x7B) // deg 
			Ascii = 27;
		else if (Ascii == ' ')
		    Ascii = 28;


	}
	else
	{
	    Ascii -= ' ';  //h table OASCII 20H~7EH إ, Ǹ֥βŸHŦrťN
    }
	drawLcdChar(Xpos, Ypos,font ,(font->table+Ascii*((font->width/8+1)*(font->high))));	 

/* @Ӧre 1byte(7  dot) * 11 = 11bytes
   @Ӧre 2byte(9  dot) * 15 = 30bytes
   @Ӧre 2byte(10 dot) * 17 = 34bytes
   @Ӧre 3byte(23 dot) * 44 = 132bytes
*/
}


/**************************************************************************************
\yz: 	b̹ܤ@ӦrŦ
    J: 	uint8_t* str    rŦw
            uint16_t x,y	ؼܦm
			uint8_t	 font	r
			uint16_t bcolor	IC
			uint16_t color	r^C
			uint8_t  mode   ҦA0-z1-Dz
    X: 	L
**************************************************************************************/
void printLcdString(uint8_t *str,uint16_t x,uint16_t y,sFONT *font,uint16_t bcolor,uint16_t color,uint8_t mode)
{

	if (mode == 0)
		s_Transparent = 0;	//z
	else
		s_Transparent = 1;	//z
	s_TextColor = color;	//r
	s_BackColor = bcolor;	//I
//	*(str+displayLength) = 0;
	while ((*str != 0))	
	{
		lookLcdTableChar(x, y, font , *str++);	//d
	 	x += font->width;	  //ڦrxb
	}
//	displayLength = 0;
}


/*******************************************************************************
*	ƦW: 
*	  : Xpos GX
*			YPos GY
*			Length    G
*			Direction GV(HorizontalAVertical)
*	  ^: L
*	\  : bLCDWe1u
*/
void drawLcdLine(uint16_t Xpos, uint16_t Ypos, uint16_t Length, uint8_t Direction)
{
	uint32_t i = 0;

	/* ]mu_l */
//	XY_Coordinate(Xpos, Ypos);

	if (Direction == HORIZONTAL)	/* u */
	{
//		writeCommand(0x02);		//MRWC  REG[02h] -- Memory Read/Write Command
		for (i = 0; i < Length; i++)
		{
//			writeData(s_TextColor);
//			Chk_Busy();
		}
	}
	else	/* u */
	{
		for (i = 0; i < Length; i++)
		{
//			writeCommand(0x02);		//MRWC  REG[02h] -- Memory Read/Write Command
//			writeData(s_TextColor);
		
			Ypos++;
//			XY_Coordinate(Xpos, Ypos);
		}
	}
}

/*******************************************************************************
*	ƦW: 
*	  : Xpos GX
*			YPos GY
*			Height G
*			Width  Ge
*           fill   : 0   1:
*	  ^: L
*	\  : bLCDWe@ӯxή
*/
void drawLcdRect(uint16_t Xpos, uint16_t Ypos, uint8_t High, uint16_t Width,uint8_t fill)
{
	/*
	 ---------------->---
	|(XposAYpos)        |
	V                    V  Height
	|                    |
	 ---------------->---
		  Width
	*/

    if ( fill == FILL) //
	{
	    uint16_t i;
		for (i = Ypos ; i < High ;i++)
		{
			 drawLcdLine(Xpos, i , Width , HORIZONTAL);
		}
	}
	else
	{
	    drawLcdLine(Xpos, Ypos, Width, HORIZONTAL);  			/*  */
	    drawLcdLine(Xpos, Ypos + High, Width, HORIZONTAL);	/*  */

	    drawLcdLine(Xpos, Ypos, High, VERTICAL);				/*  */
	    drawLcdLine(Xpos + Width, Ypos, High, VERTICAL);		/* k */
	}
}

/* ϶ø  Ww   μe  ϶s  */

void drawLcdBlockBackGround(sBLOCK *block,uint16_t length,uint16_t width)
{
	uint16_t num,x = block->leftUpX,y = block->leftUpY;
	uint16_t Bkground  = s_TextColor;
	
// ®
	s_TextColor = BLACK;
	drawLcdLine(x+2, y, length-4, HORIZONTAL);	 //Wu
	drawLcdLine(x+2, y+width-1, length-4, HORIZONTAL);//Uu

	drawLcdLine(x, y+2, width-4, VERTICAL);	  //u
	drawLcdLine(x+length-1, y+2, width-4, VERTICAL);	  //ku
		
	drawLcdLine(x+1, y+1, 2, HORIZONTAL);
	drawLcdLine(x+1, y+2, 1, HORIZONTAL); //WR

	drawLcdLine(x+length-3, y+1, 2, HORIZONTAL);
	drawLcdLine(x+length-2, y+2, 1, HORIZONTAL); //kWR

	drawLcdLine(x+1, y+width-2, 2, HORIZONTAL);
	drawLcdLine(x+1, y+width-3, 1, HORIZONTAL);//UR

	drawLcdLine(x+length-3, y+width-2, 2, HORIZONTAL);
	drawLcdLine(x+length-2, y+width-3, 1, HORIZONTAL);//kUR

	s_TextColor =  block->backcolor;

//
	drawLcdLine(x+3, y+1, length-6, HORIZONTAL);
	drawLcdLine(x+2, y+2, length-4, HORIZONTAL);
	for (num = y+3 ;num < (y+width-3);num++)
		drawLcdLine(x+1, num, length-2, HORIZONTAL);
	drawLcdLine(x+2, y+width-3, length-4, HORIZONTAL);
	drawLcdLine(x+3, y+width-2, length-6, HORIZONTAL);

	s_TextColor = Bkground;
}



void highLight(uint8_t *str,sFONT *font,uint16_t Xpos, uint16_t Ypos,uint16_t color,uint16_t color1,sBLOCK *block,uint8_t highLight)
{

    if (highLight == HIGH_LIGHT)
	{
        // իu@
	    s_TextColor = WHITE;
	    drawLcdLine(Xpos - 1, Ypos, font->high, VERTICAL);
	    s_TextColor = color;
	    s_BackColor = WHITE; //թ¦r
	}
	else
	{	
        // Iu@	
 	    s_TextColor = block->backcolor;
	    drawLcdLine(Xpos - 1, Ypos, font->high, VERTICAL);
	    s_TextColor = color1;
	    s_BackColor = block->backcolor; //
	}
	while ((*str != 0))	
	{
		lookLcdTableChar(Xpos, Ypos, font , *str++);	//d
	 	Xpos += font->width;	  //ڦrxb
	}
}

uint32_t timeStamp1,timeStampe2;

void pasteAllBackground(void)
{

//	lcdClear(blockColor);
	DRAW_KEY_B1;
	DRAW_KEY_B2;
	DRAW_KEY_B3;
	DRAW_KEY_B4;
	DRAW_KEY_B5;
	DRAW_KEY_R4;
	DRAW_KEY_R3;
	DRAW_KEY_R2;
	DRAW_KEY_R1;
}

void pasteB0ToB9(void)
{
    s_TextColor = GRAY2;
    drawLcdRect(0,0, 229, 386 ,FILL); // 229 ,386
	DRAW_KEY_B1;
	DRAW_KEY_B2;
	DRAW_KEY_B3;
	DRAW_KEY_B4;
	DRAW_KEY_B5;
	DRAW_KEY_R4;
	DRAW_KEY_R3;
	DRAW_KEY_R2;
	DRAW_KEY_R1;
}






