
#ifndef _KEYBOARD_H
#define _KEYBOARD_H

#define key_OVP			17
#define key_OPP			18
#define key_OCP			19
#define key_LOCK		20
#define key_UP			12
#define key_DOWN		13
#define key_LEFT		14
#define key_RIGHT		15
#define key_OK			16
#define key_SHIFT		21
#define key_ESC			22
#define key_VSET		23
#define key_ISET		24
#define key_RECALL		25
#define key_METER		26
#define key_ONOFF		27
#define key_MENU		28
#define key_0			 1
#define key_1			 2
#define key_2			 3
#define key_3			 4
#define key_4			 5
#define key_5			 6
#define key_6			 7
#define key_7			 8
#define key_8			 9
#define key_9			10 
#define key_DP			11

#define key_SelfTest	55
#define key_Normal		56
#define key_Debug		57


/* Global--------------------------------------------*/

extern uint8_t	      keyState;
#define KEY_SCAN		0		/* S1	       */
#define KEY_PULSE		1		/* S2          */
#define KEY_NEW			2		/* S3  new key */
#define KEY_PRESSED		3		/* S4  pressed */


extern uint8_t	      returnKey;

extern uint8_t keyType;
#define KEY23	1	 // BK precision  ­O
#define KEY29	0	 // ITECH խO




//extern uint32_t vfdadjcount;

#define NORMAL_COUNT	4000
#define UI_TEST_COUNT	1500

//extern uint32_t vfdcount ;

extern uint8_t keyHold, leftRotary, rightRotary;
extern uint8_t rxVFDBuffer[10];

void keyTickIsr(void);

uint8_t getKey(void);
uint8_t getKey1(void);

#endif


