

#ifndef	_SYSTICK_H
#define _SYSTICK_H
#include <stdint.h>


#define OVPCAL_TIME		30000	// ms
#define OCPCAL_TIME		40000	// ms

/* 
wq timer c P flag

	flag = 1,ܦcounterbQϥΤ
	count P tmcount  

*/
typedef struct
{
	volatile uint32_t count;	/*  */
	volatile uint8_t flag;		/* ϥκX  */
}SOFT_TIMER;

#define TIMER_COUNT     	50		  /* Xtimer */
extern SOFT_TIMER	softTimer[TIMER_COUNT];
#define MAIN_COUNT							0  /* system tick   1ms */
#define BUZZER_COUNT						1
#define ERROR_MESSAGE_COUNT 				2
#define TIME_ALARM_COUNT					3
#define SIGN_STAR_COUNT     				4  // count per second
#define TIME_ALARM_COUNT1					5
#define TIME_ALARM_COUNT2					6
#define ON_THE_FLY_COUNT					7
#define RS485_COUNT							8
#define RS232_COUNT							9
#define GPIB_LAN_COUNT						10
#define USB_VCP_COUNT						11
#define TEMP_COUNT							12

#define WAIT_OVP_OCP_COUNT					13

#define DISP_COUNT							14
#define QUERY_IPADDR_COUNT					15

#define RS485_PARALLEL_COUNT				16
#define KEY_HOLD_COUNT						17
#define PARALLEL_PARAMETER_COUNT			18
#define CAL_IOUT_COUNT						19
#define PARALLELONOFFDEBOUNCE_COUNT			20
#define SHOW_VERSION_COUNT					21
#define USB_RESTART_COUNT					22
#define SLAVE_COUNT							23
#define TEMP_BEEP_COUNT						24	// OTW
#define OTW_NTC_STATUS_COUNT				25
#define RS485_ANTI_COLLISION_COUNT			26
#define RS485_QVI_BROADCAST_COUNT			27
#define DELAY_CLR_PREVENT_TO_JAM_COUNT 		28
#define PARALLEL_MASTER_INIT_CHECK_COUNT	29
#define CHAIN_SLAVE_CONNECT_STATUS_COUNT	30
#define SCPI_RESET_COUNT					31


//#define IS_SEC0_5   (softTimer[MAIN_COUNT].count & BIT16)
//#define IS_SEC1_0   (softTimer[MAIN_COUNT].count & BIT17)

extern uint32_t beepDuration;
extern uint8_t cursoronoff;



void delayMs(uint32_t nMs);
void delay5us(uint32_t nus);
void imeEvent(void);
void beepTimeOut(void);
void errorMessageTimeOut(void);
void rtcReadPerSecond(uint32_t time);
void refreshdisplayFreq(uint32_t time);
void reqMeasure(uint32_t time);
void checkOnTheFlyCursor(void);
void setOnTheFly(void);
void queryIPaddr(uint32_t time);
void showVer(uint32_t time);
void clearOnTheFlyCursor(void);

#endif
