// Variables for PVS


#define VERSION  	  SCPI_DEV_VERSION

uint8_t     shiftStatus;		// shiftŲA
uint8_t     lockStatus;			// lockA
uint16_t	outputStatus;		// outputA
uint16_t	lastoutputStatus;	// W@outputA  ,تOread Y@ displayFresh ] 1 ,(display~)
uint8_t     onoffStatus;		// ھڦO on offA
											
uint8_t		memoryNumber;		// sbĴX eeprom

uint8_t		meterStatus;		// MeterA
uint8_t		ProtOVActivation;  //OVP protect
uint8_t		ProtOCActivation;  //OCP protect
uint8_t		ProtOPActivation;
uint8_t		CVtoCCActivation;
uint8_t		CCtoCVActivation;
uint8_t		protsw;

uint8_t		OVPOccurred;
uint8_t		OCPOccurred;
uint8_t		OPPOccurred;
uint8_t		VCPOccurred;
uint8_t		CVPOccurred;

uint8_t		operationState;

uint16_t	fullScale;
//float		vMax;
//float		vMin;

//float		iMax;
//float		iMin;
	
//float		pMax;
//float		pMin;
//float		OVPMax;
//float		OVPMin;
//float		OCPMax;
//float		OCPMin;
//float		OPPMax;
//float		OPPMin;

uint16_t    vCal[6];
uint16_t    iCal[6];
uint16_t	vDac[6];
uint16_t	iDac[6];
float       vMeter;
float       iMeter;

//float		vSet;
float       oldvSet;
//float		iSet;
float       oldiSet;
float		pSet;
//float		vOut;
float       oldvOut;
//float		iOut;
//float       oldiOut;
float		pOut;
//float		OVPSet;
//float		OCPSet;
//float		OPPSet;	

float       bkvSet;
float		bkiSet;
float		bkOVPSet;
float		bkOCPSet;
float		bkOPPSet;	








//float		SRvSet;
//float		SRiSet;
float       VSRMax;
float       ISRMax;
uint16_t	timerHR;
uint8_t		timerMN;
uint8_t		timerSE;
uint8_t     timerONOFF;
uint32_t    runningTimer;

uint8_t		optCard; // 0: no opt. card  1: GPIB/LAN card exist




const uint8_t	default_LANIPAddr[4] =  {0,0,0,0};
const uint8_t	default_LANMask[4] = {0,0,0,0};
const uint8_t	default_LANGateway[4] = {0,0,0,0};

uint8_t     GPIBAddr = 1;
uint8_t		LANIPMode;
uint8_t		backupLANIPMode;
uint8_t		LANIPAddr[4];
uint8_t		LANMask[4];
uint8_t		LANGateway[4];

uint8_t		currentLANIPAddr[4];
uint8_t		currentLANMask[4];
uint8_t		currentLANGateway[4];
uint8_t		MACaddress[6];






uint8_t		LANIPAddrTemp[4];
uint8_t		LANMaskTemp[4];
uint8_t		LANGatewayTemp[4];


uint8_t		R485Baud;
uint8_t     rs485parityDataBits = 0;
uint8_t     rs485stopBits = 0;
uint8_t		R232Baud;
uint8_t     rs232parityDataBits = 0;
uint8_t     rs232stopBits = 0;

//uint8_t     location;
uint8_t		groupNumber;
uint8_t		beepActivation;
uint8_t		powerOnMode;
uint8_t		powerOn_OnOff;
float		powerOnVolt;
float       powerOnCurrent;
//float		limitVMin;
//float		limitVMax;
//float		limitIMin;
//float		limitIMax;
float		limitPMin; 
float		limitPMax;



uint8_t		extVMode;
float		adcVolt;
float		adcCurrent;
uint8_t		extIMode;
uint8_t		extProgRange;
uint8_t		extMonRange;
uint8_t		extShutOffLogic;


uint8_t		extEnable;
uint8_t		parallelMode;	  // on   off
uint8_t		parallelRole;	  // master Slave
uint8_t		chainMode;		  // on   off
uint8_t		chainAddr;		  // 
uint8_t		chainAddrSlave;


uint8_t     calPV = 1;
uint8_t     calPI = 1;
uint8_t     presentPoint = 1;
uint8_t     calState;
uint16_t    iAdc;
uint16_t    vAdc;

uint16_t	adRangeHigh = 30000;
uint16_t	adRangeLow = 800;

uint8_t 	ovpCalState;
uint8_t     ocpCalState;
uint8_t		restoreFactoryParameter;


uint8_t     programONOFF;
uint8_t     programGroup = 1;
uint8_t     programGroupTemp = 1;
uint8_t     step;

uint8_t     programParameter[7];
//#define 	PROG_ACT		0
//#define 	PROG_VOLTAGE	1
//#define 	PROG_CURRENT	3
//#define 	PROG_TIMER		5

float    	voltage; 
float    	current;
float    	timer;
uint16_t 	repeat;
uint16_t    totalRepeat;


uint16_t 	repeatGroup[10];
uint8_t  	linkNumberGroup[10];


uint8_t  	programState;		   // program run state
uint32_t 	programRunningTimer;   // program ɶ



numericaleInputParameter numericalInput;

#define FLOAT	1
#define INTEGER	0



#define PT_SHIFT_RIGHT		BIT0


#define IS_PT_SHIFT_RIGHT     numericalInput.flag & BIT0
#define CLR_PT_SHIFT_RIGHT	 numericalInput.flag &= (~BIT0)
#define SET_PT_SHIFT_RIGHT	 numericalInput.flag &= (~BIT0)







typedef struct {
	uint32_t count;
	uint32_t rcount;
}COM_COUNT;

uint8_t usbBuffer[100];
COM_COUNT vreadCount,ireadCount,outputStatusCount,vSetCount,iSetCount,OCPSetCount,OVPSetCount,OPPSetCount;
COM_COUNT SRvSetCount, SRiSetCount;
uint8_t checkItem; // debugError 
#define MAXITEM 	11
uint32_t totalCount, upCount ,downCount,noiseCount;
uint32_t waitMBStatus = 0; // MB ready 
uint32_t waitGBStatus = 0; // 
uint16_t faultStatus;  // PO su ~A
uint16_t NTCStatus; // OTW NTC status

uint8_t extCalTotalPoint = 2;
uint16_t extCalVAd[2];
uint16_t extCalIAd[2];
float extCalV[2];
float extCalI[2];

float mADc_v;
float bADc_v;
float mDAc_v;
float bDAc_v;


float mADc_i;
float bADc_i;
float mDAc_i;
float bDAc_i;

//uint8_t	entry_remote = 0;
uint8_t remote = 0;

COM_TypeDef transparentDEVICE;
COM_TypeDef	transparentHOST = NOT_PROGRAMMING;

float voltagerescurr;	 	// ~ qq wqy
float currentrescurr;	// ~ qqB wqy


//PVS

uint8_t pvsONOFF,pvsTableNumState;
uint8_t curve;
uint16_t percentage;
float percent;
float Rule,Vmp,Pmp,Material;
uint16_t pvsPoint;
float pvsVoltage,pvsCurrent;
uint8_t pvCtrlMode;

//float  	pvsG;			//ӫ
//float  	pvsvmp,pvspmp;
//int16_t   pvsarray;		// }Cjp
//int16_t	pvsT;			//ū
//int8_t 	pvsformula;		//
//int8_t 	pvsmaterial;	//


uint8_t pvsBuffer[29 * 2];

uint8_t machine3KW;
uint8_t machine1000;
float pMax3KW;
//float		actualPMax;
float adjsumiSet;








